;=====================================================================================;
;fpaq0 - Stationary order 0 file compressor.
;(C) 2004, Matt Mahoney under GPL, http://www.gnu.org/licenses/gpl.txt
;=====================================================================================;
;Feb.20 2006 - 10:37
;fpaq.asm
;fasmw code implementation from Nikolay Petrov
;Win32 console program
;compile from fasmw IDE(flat assembler compiler for Windows - http://www.flatassembler.net/)
;or from command line:  fasm fpaq.asm
;minimum system requirement -  x86, 32-bit processor type(at least 80686);
;=====================================================================================;
MAX_ARGUMENTS	= 5  ;max command line arguments
P_SHIFT 	= 12 ;12 is default in fpaq0.cpp(see at row 87).
		     ;Possible values - from 8 to 15
;=====================================================================================;
format pe console
entry Start
;=====================================================================================;
include "win32a.inc"
include "fpaq.inc"
;=====================================================================================;
section ".text" code readable executable
;=====================================================================================;
FPAQ0:
     InitEncoder	DECOMPRESS
;esi - insteam; edi - outstream; ebx = x; ebp = cxt; c match with cxt
;loop:
;decode extra bit. if extra bit != 0 goto .finish
     ed_extra_bit	DECOMPRESS

.DECOMPRESS.bloop:
     calc_xmid
     mov		ecx,ebp
     add		ebp,ebp
     cmp		eax,ebx
     jae		@f
     lea		edx,[eax+1]
     mov		[x1],edx
     mov		eax,[x2]
     update		DECOMPRESS,0
@@:;bit=1
     mov		[x2],eax
     mov		edx,[x1]
     or 		ebp,1
     update		DECOMPRESS,1
.DECOMPRESS.do:
     shl		eax,8
     or 		ax,0xff
     mov		edx,[x1]
     shl		edx,8
     mov		[x1],edx
     mov		[x2],eax
     inc		esi
     get_x
.DECOMPRESS.while:
     xor		edx,eax
     test		edx,0ff000000h
     je 		.DECOMPRESS.do
     test		ebp,100h
     je 		.DECOMPRESS.bloop
     mov		[edi],ebp
     inc		edi
     cmp		edi,outfile.eos   ;end point of outfile.stream
     jb 		.DECOMPRESS.loop
     ;store buffer
     mov		edi,outfile.stream
     add		[outfile.ftell],sizeof.stream
     invoke		WriteFile,[outfile.handle],edi,sizeof.stream,temp,0
     jmp		.DECOMPRESS.loop
;=====================================================================================;
     InitEncoder	COMPRESS
;esi - insteam; edi - outstream; ebx = c; ebp = cxt
;loop:
     movzx		ebx,byte[esi]
     inc		esi
;encode extra bit --> 0
     ed_extra_bit	COMPRESS

.COMPRESS.bloop:
     calc_xmid
     mov		ecx,ebp
     lea		ebp,[2*ebp]
     add		ebx,ebx
     test		ebx,0x100
     jne		@f
     lea		edx,[eax+1]
     mov		[x1],edx
     mov		eax,[x2]
     update		COMPRESS,0
@@:;bit=1
     mov		[x2],eax
     mov		edx,[x1]
     or 		ebp,1
     update		COMPRESS,1
@@:
     mov		edi,outfile.stream
     add		[outfile.ftell],sizeof.stream
     invoke		WriteFile,[outfile.handle],edi,sizeof.stream,temp,0
     jmp		@f
align	8
.COMPRESS.do:
     rol		eax,8
     stosb
     mov		al,-1
     mov		[x2],eax
     case		edi,outfile.eos,@r
@@:
     mov		eax,[x2]
     mov		edx,[x1]
     shl		edx,8
     mov		[x1],edx
     nop
     nop
.COMPRESS.while:
     xor		edx,eax
     test		edx,0ff000000h
     je 		.COMPRESS.do

     test		ebp,100h
     je 		.COMPRESS.bloop

     dec		[infile.flen]
     jne		.COMPRESS.loop
;encode eof extra bit --> 1
     mov		ecx,[ct]
     cmp		ecx,(1 shl P_SHIFT)-1
     jb 		@f
     ;Encoder.flush()
     mov		eax,[x1]
     bswap		eax
     mov		edx,-1
     mov		[edi],eax
     mov		[edi+4],edx
     add		edi,5
     jmp		.finish
align	8
@@:
     calc_xmid		1
     ;Encoder.flush()
     mov		edx,[x1]
     xor		edx,eax
     bswap		eax
     stosd
 rept 3 n
    {test		edx,-1 shl (8*n)
     je 		.finish
     dec		edi}

.finish:
     sub		edi,outfile.stream
     je 		@f
     invoke		WriteFile,[outfile.handle],outfile.stream,edi,temp,0
     add		[outfile.ftell],edi
@@:
     mov		esp,[v_stack.save]
     pop		edi esi ebx ebp
     ret
;=====================================================================================;
; Program entry point
align	8
Start:
     GetFpaqArgs
     mov		eax,[argv+4]
     movzx		eax,word[eax]
     case		eax,"c",InitMemory  ;if equ - Mode = COMPRESS
     jneq		eax,"d",PrintHelp   ;if equ - Mode = DECOMPRESS
     inc		[Mode]
InitMemory:
     invoke		CreateFile, [argv+8],GENERIC_READ,FILE_SHARE_READ,0,\
				    OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL+FILE_FLAG_SEQUENTIAL_SCAN,0
     case		eax,INVALID_HANDLE_VALUE,ShowLastError
     mov		[infile.handle],eax
     invoke		GetFileSize,eax,0
     test		eax,eax
     je 		ShowLastError
     mov		[infile.flen],eax
     inc		eax
     je 		ShowLastError
     invoke		VirtualAlloc,0,eax,MEM_COMMIT,PAGE_READWRITE
     test		eax,eax
     je 		ShowLastError
     mov		[infile.stream],eax
     invoke		ReadFile,[infile.handle],eax,[infile.flen],infile.ftell,0
     test		eax,eax
     je 		ShowLastError
SetTimer:
     clock
     mov		[timer],eax
OpenOutFile:
     invoke		CreateFile, [argv+12],GENERIC_WRITE,0,0,\
				    CREATE_ALWAYS,FILE_ATTRIBUTE_NORMAL+FILE_ATTRIBUTE_ARCHIVE,0
     case		eax,INVALID_HANDLE_VALUE,ShowLastError
     mov		[outfile.handle],eax
RunEncoderMode:
     mov		eax,[Mode]
     mov		ecx,FPAQ0.COMPRESS
     mov		edx,FPAQ0.DECOMPRESS
     test		eax,eax
     cmovne		ecx,edx
     call		ecx
GetTimer:
     clock		[timer]
     mov		[timer],eax
     fild		[timer]
     fmul		qword[timer+4]
     fstp		qword[timer+4]
PrintResults:
     cinvoke		printf, szFinMsg,[argv+8],[infile.ftell],\
					 [argv+12],[outfile.ftell],\
					 [timer+4],[timer+8]
ExitProg:
     invoke		ExitProcess,0
;=====================================================================================;
assert:
     cinvoke		printf,assertMsg
     jmp		abort
;=====================================================================================;
ShowLastError:
     call		[GetLastError]
     mov		edi,eax
     invoke		FormatMessage, FORMAT_MESSAGE_ALLOCATE_BUFFER+FORMAT_MESSAGE_FROM_SYSTEM,\
				       0,eax,LANG_NEUTRAL,ebx,0,0
     cinvoke		printf,szErr,edi,[ebx]
abort:
     invoke		ExitProcess,1
;=====================================================================================;
PrintHelp:
     cinvoke		printf,lpHelpMsg
     jmp		abort
;=====================================================================================;
section ".data" data readable writeable
 temp		dd 0
 Mode		dd 0
 timer		dd 0
		dq 0.001

 szFinMsg	db "%s (%ld bytes) -> %s (%ld bytes) in %1.2f s.",10,0
 lpHelpMsg	db "To compress:   fpaq0 c input output",10,\
		   "To decompress: fpaq0 d input output",10,0
 assertMsg	db "assert(xmid >= x1 && xmid < x2)",10,0
 szErr		db "error %d: %s",0
align	4

 infile:;struct
     .handle	dd ?;handle file object
     .stream	dd ?;stream
     .flen	dd ?;file lenght
     .ftell	dd ?;current position

 outfile:;struct
     .handle	dd ?
     .ftell	dd ?
     .stream	db 8000h dup(?)
     .eos	dd 2 dup(?)
 sizeof.stream	= outfile.eos - outfile.stream

 argc		dd ?
 argv		dd MAX_ARGUMENTS dup(?)

 v_stack:;struct
     .save	dd ?
     .ss	dd 256 dup(?)
     .esp	dd (1+1+256*2) dup(?);x1,x2,ct[256][2] zero memory
     .end	dd 16 dup(?)
;=====================================================================================;
section ".idata" import data readable

     library kernel32,'KERNEL32.DLL',\
	     msvcrt,  'MSVCRT.DLL'

     import kernel32,\
	    ExitProcess,   'ExitProcess',\
	    CreateFile,    'CreateFileA',\
	    ReadFile,	   'ReadFile',\
	    WriteFile,	   'WriteFile',\
	    GetCommandLine,'GetCommandLineA',\
	    VirtualAlloc,  'VirtualAlloc',\
	    GetTickCount,  'GetTickCount',\
	    GetLastError,  'GetLastError',\
	    FormatMessage, 'FormatMessageA',\
	    GetFileSize,   'GetFileSize'

     import msvcrt,\
	    printf,	    'printf'
;=====================================================================================;
;section '.reloc' fixups data readable discardable